"use strict";Object.defineProperty(exports,"__esModule",{value:!0});var ramp=exports.ramp="\n  float ramp(float t){\n    t *= 2.0;\n    if (t >= 1.0) {\n      t -= 1.0;\n      t = log(0.5) / log(0.5*(1.0-t) + 0.9332*t);\n    }\n    return clamp(t, 0.001, 10.0);\n  }\n",Lum=exports.Lum="\n  float Lum(vec3 c){\n    return 0.299*c.r + 0.587*c.g + 0.114*c.b;\n  }\n",ClipColor=exports.ClipColor="\n  vec3 ClipColor(vec3 c){\n    float l = Lum(c);\n    float n = min(min(c.r, c.g), c.b);\n    float x = max(max(c.r, c.g), c.b);\n  \n    if (n < 0.0) c = (c-l)*l / (l-n) + l;\n    if (x > 1.0) c = (c-l) * (1.0-l) / (x-l) + l;\n  \n    return c;\n  }\n",SetLum=exports.SetLum="\n  vec3 SetLum(vec3 c, float l){\n    float d = l - Lum(c);\n  \n    c.r = c.r + d;\n    c.g = c.g + d;\n    c.b = c.b + d;\n  \n    return ClipColor(c);\n  }\n",Sat=exports.Sat="\n  float Sat(vec3 c){\n    float n = min(min(c.r, c.g), c.b);\n    float x = max(max(c.r, c.g), c.b);\n  \n    return x - n;\n  }\n",SetSat=exports.SetSat="\n  vec3 SetSat(vec3 c, float s){\n    float cmin = min(min(c.r, c.g), c.b);\n    float cmax = max(max(c.r, c.g), c.b);\n  \n    vec3 res = vec3(0.0);\n  \n    if (cmax > cmin) {\n  \n      if (c.r == cmin && c.b == cmax) { // R min G mid B max\n        res.r = 0.0;\n        res.g = ((c.g-cmin)*s) / (cmax-cmin);\n        res.b = s;\n      }\n      else if (c.r == cmin && c.g == cmax) { // R min B mid G max\n        res.r = 0.0;\n        res.b = ((c.b-cmin)*s) / (cmax-cmin);\n        res.g = s;\n      }\n      else if (c.g == cmin && c.b == cmax) { // G min R mid B max\n        res.g = 0.0;\n        res.r = ((c.r-cmin)*s) / (cmax-cmin);\n        res.b = s;\n      }\n      else if (c.g == cmin && c.r == cmax) { // G min B mid R max\n        res.g = 0.0;\n        res.b = ((c.b-cmin)*s) / (cmax-cmin);\n        res.r = s;\n      }\n      else if (c.b == cmin && c.r == cmax) { // B min G mid R max\n        res.b = 0.0;\n        res.g = ((c.g-cmin)*s) / (cmax-cmin);\n        res.r = s;\n      }\n      else { // B min R mid G max\n        res.b = 0.0;\n        res.r = ((c.r-cmin)*s) / (cmax-cmin);\n        res.g = s;\n      }\n  \n    }\n  \n    return res;\n  }\n",Mix=exports.Mix="\n  vec3 Mix(vec3 a, vec3 b, float opacity) {\n    return mix(a, b, opacity);\n  }\n",ClampRGBVec3=exports.ClampRGBVec3="\n  vec3 ClampRGBVec3(vec3 c) {\n    return clamp(c / 255.0, 0.0, 1.0);\n  }\n";
//# sourceMappingURL=shaders-functions.js.map